/* AtEnd.Cfg for AdeptXBBS
   Edit the Call AdeptChainRexx Line to reflect the drive letter adept is
   installed on in your system.                                         */
Arg Line
ADDRESS CMD "e:\orion\fecvt.cmd"
ADDRESS CMD "e:\orion\ipfix.cmd"
ADDRESS SRX
If RxFuncQuery( 'SysLoadFuncs' ) Then Do
        Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
        Call SysLoadFuncs
        End

FSpec = '\orion\System\Line' || Line || '\*.*'

Call SysFileTree FSpec, 'File', 'FO'
If ( File.0 > 0 ) Then
        Do i=1 to File.0
                FileNameOnly = Space(SubStr(File.i, LastPos('\', File.i)+1))
                Call AdeptLog Line, 3, "Left over file #"i "["FileNameOnly"]"
                If ( SysFileDelete( File.i ) ) Then Call AdeptLog Line, 3, "Left over file #"i "["FileNameOnly"] could not be deleted"
                Else Call AdeptLog Line, 3, "Left over file #"i "["FileNameOnly"] deleted"
        End

/*
Ŀ
                   AdeptCaller v1.00 (C) 1996 Robert Stephens (3:622/421)               
                                                                                                                                                          
                                       A Recent Callers Generator for AdeptXBBS.                                  
Ĵ
               Whats new in v1.00 :                                                                                               
                                                                                                                                                          
                  Changed the Name from AdeptXBBSCaller to AdeptCaller                           
                  All Known Bugs Removed                                                                                         
                  Most Kludgy Code Removed :P                                                                            
                  Uses Much Less Memory                                                                                          
                  Update of Today's Callers List is 2-8x's Faster than v0.80         
                                                                                                                                                          
               I can be contacted at :                                                                                            
               E-Mail : ourjs@net-unix.newcastle.edu.au                                                           
*/
Version = '1.00'

/* Configuration is Below ---------------------------------------------*/

Input_Time_File = 'e:\orion\Temp\Login_Time.'Line
Today_File = 'e:\orion\Text\0_Days_Old.Asc'
Text_Path = 'e:\orion\Text\'

/* Below are the default colours which I think look ok, however, the
   colours may not turn up correctly in Adept (one day, Adeptsoft may
   fix the meta colour bugs :), they look right locally and in Callers.Cmd */

Title_Colour = '{B2{FG'
Shadow_Colour = '{F9'      /* {F1 looks right for Adept 1.06 and below */
Copyright_Colour = '{FD'
Heading_Colour = '{FG'
Underline_Colour = '{FA'
Count_Colour = '{FG'
Name_Colour = '{FC'
Line_Colour = '{FB'
Baud_Colour = '{FB'
Location_Colour = '{FF'
LogOn_Colour = '{F4'
LogOff_Colour = '{F4'
Download_K_Colour = '{FE'
Calls_Colour = '{FE'

/* End of Configuration -----------------------------------------------*/


if (Line = 0) Then Call Local

BBS_Name = AdeptGetVar(Line,137)
Login_Time = Stream(Input_Time_File,'c','query exists')
If Login_Time = '' Then Do
        Call AdeptLog Line, 3, "AdeptCaller: (Error) Couldn't find Login Time file - Exiting... "
        Exit
End
Login_Time = Stream(Input_Time_File,'c','query datetime')

Check_Maint = Stream(Today_File,'c','query datetime')
Parse Value Word(Check_Maint,1) With Crap '-' Today_File_Date '-' Crap
Parse Value Date('E') With Todays_Day '/' Month '/' Year

If Todays_Day = Today_File_Date Then Call Today
Call Do_Maintenance
/* Program Ends through a call to the "Today" Function Below */

/*-----| Update Today's Lists |-----------------------------------------------*/
Today:
        Parse Value Word(Login_Time,2) With LogOn_Hour ':' LogOn_Minute ':' Seconds
        Check_State = AdeptGetVar(Line,7)
        If Check_State = '' Then Do
           Call AdeptLog Line, 3, "AdeptCaller: 'State' Field Blank"
           Call AdeptLog Line, 3, '(Error)      Possible Carrier Drop during New User LogIn'
           Call AdeptLog Line, 3, '             Not Adding to Caller List'
           Exit
        End
        Call AdeptSleep Line, 32
        Parse Value Time() With LogOff_Hour ':' LogOff_Minute ':' Seconds
        If LogOn_Hour = LogOff_Hour Then Mins = LogOff_Minute - LogOn_Minute
        If LogOn_Hour \= LogOff_Hour Then Do
           Mins = LogOff_Minute
           Hour_Difference = LogOff_Hour - LogOn_Hour
           If Hour_Difference >= 2 Then Mins = (Mins + (Hour_Difference * 60)) - LogOn_Minute
           If Hour_Difference <= 1 Then Do
                  Temp_Mins = 60 - LogOn_Minute
                  Mins = Mins + Temp_Mins
           End
        End
        Check_Today_File = Stream(Today_File,'c','query exists')
        If Check_Today_File = '' Then Call Make_New
        rc = LineIn(Today_File)  /* Read in Time Today, New Users, Kilobytes etc */
        Call Stream Today_File,'c','Close'
        Parse Var rc Header.1 Time_Today New_Users_Today BBS_DL_K BBS_UL_K Bogus
        Time_Today = Time_Today + Mins
        Parse Value LineIn(Input_Time_File) With User_DL_K_Today User_UL_K_Today
        Call Stream Input_Time_File,'c','Close'
        ry = AdeptGetVar(Line,36)
        If ry \= 0 Then Do  /* If user has already dl today */
           User_DL_K_Call = AdeptGetVar(Line,36)
           User_DL_K_Call = User_DL_K_Call - User_DL_K_Today
           User_DL_K_Call = AdeptGetVar(Line,36) - User_DL_K_Today /* K this Call */
           BBS_DL_K = BBS_DL_K + User_DL_K_Call
        End
        Else Do
           User_DL_K_Call = AdeptGetVar(Line,36)
           BBS_DL_K = BBS_DL_K + User_DL_K_Call
        End
        rz = AdeptGetVar(Line,35)
        If rz \= 0 Then Do  /* If user has already ul today */
           User_UL_K_Call = AdeptGetVar(Line,35) - User_UL_K_Today /* K this Call */
           BBS_UL_K = BBS_UL_K + User_UL_K_Call
        End
        Else Do
           User_UL_K_Call = AdeptGetVar(Line,35)
           BBS_UL_K = BBS_UL_K + User_UL_K_Call
        End
        Calls_To_BBS = AdeptGetVar(Line,30)

    If Calls_To_BBS = 1 Then New_Users_Today = New_Users_Today + 1
        Call AdeptSleep Line, 32
    Call LineOut Today_File,Count_Colour || Left(Header.1 + 1,3) || ' ' || Name_Colour || Left(AdeptGetVar(Line,2),19,' ') || '  ' || Line_Colour || Left(Line,2,' ') || ' ' || Baud_Colour || Right(AdeptGetVar(Line,233),5,' ') || '  ' || Location_Colour || Left(AdeptGetVar(Line,6) || ', ' || AToUpper(AdeptGetVar(Line,7)),18,' ') || '  ' || LogOn_Colour || LogOn_Hour || ':' || LogOn_Minute || '  ' || LogOff_Colour || LogOff_Hour || ':' || LogOff_Minute || '  ' || Download_K_Colour || Left(User_DL_K_Call,5) || Calls_Colour || Right(Calls_To_BBS,5)
        Call CharOut Today_File,Left(Header.1 + 1 || ' ' || Time_Today || ' ' || New_Users_Today || ' ' || BBS_DL_K || ' ' || BBS_UL_K,30,' '),1
        Call Stream Today_File,'c','Close'
    Address Cmd '@Del ' || Input_Time_File || '>Nul'
    Address SRX
        Exit
Return
/*----------------------------------------------------------------------------*/

/*-----| Header Initialization |----------------------------------------------*/
Header_Init:
        Header.0 = 8
        Header.2 = '{CS'
    Header.5 = Copyright_Colour || Centre('AdeptCaller v' || Version || ' (C) 1996, Robert Stephens.',79)
        Header.6 = '{FG'
    Header.7 = Heading_Colour || 'No. Name                Line Baud  Location            LogOn LogOff  DL/K Calls'
    Header.8 = Underline_Colour || ''
Return
/*----------------------------------------------------------------------------*/

/*-----| Make New File For Today, with Headers |------------------------------*/
Make_New:
        Call AdeptLog Line, 3, "AdeptCaller: (Ok) Today's Caller List Created"
        Call Header_Init
        /*                               +------------ Call Number
                                         | +---------- Time Used Today (Total)
                                         | | +-------- Number of New Users Today
                                         | | | +------ Downloaded Kilobytes Today
                                         | | | | +---- Uploaded Kilobytes Today
                                         | | | | |                                                                 */
        Header.1 = Left('0 0 0 0 0',30)
    Header.3 = Strip(Centre(Shadow_Colour || "" || Title_Colour || " Today's Callers to " || BBS_Name || ' {B1',92),'T')
    Header.4 = Strip(Centre(Shadow_Colour || Copies('',Length(BBS_Name) + 20),81),'T')
        Do i = 1 To Header.0
           Call LineOut Today_File,Header.i
        End
        Call Stream Today_File,'c','Close'
Return
/*----------------------------------------------------------------------------*/

/*-----| Maintenance |--------------------------------------------------------*/
Do_Maintenance:

         Call AdeptLog Line, 3, "AdeptCaller: Running Maintenance ... "

         Todays_Size = Stream(Text_Path || '0_Days_Old.Asc','c','query size')
         Most_Callers_Size = Stream(Text_Path || 'Most_Callers.Asc','c','query size')
         Year = '19' || Year
         Call AdeptPrint Line, '\r\n{FG AdeptCaller {FEversion ' || Version || ', by Robert Stephens'

         If (Todays_Size >= Most_Callers_Size) Then Do    /* Make Most Calls Ever */
                Call AdeptPrint Line, '\r\n{FB Compiling Most Callers to BBS Ever list ...'
                Call AdeptLog Line, 3, 'AdeptCaller: (Ok) Compiling Most Ever Callers'
        Address Cmd '@COPY ' || Text_Path || '0_Days_Old.Asc ' || Text_Path || 'Temp_Most_Callers.Asc >Nul'
                Parse Value Stream(Text_Path || 'Temp_Most_Callers.Asc','c','query datetime') With Month_Numeric '-' Day '-' Year '  ' Crap
                Year = '19' || Year
                Text_Month = Month_Convert(Month_Numeric)
                rc = Tense_Convert(Day)
                Day = Strip(Day,'L',0)
                Call Header_Init

        Header.3 = Strip(Centre(Shadow_Colour || "" || Title_Colour || " Most Number of Callers to " || BBS_Name || ' Ever - ' || Day || Tense || ' ' || Text_Month || ' ' || Year ' {B1',94),'T')
        Header.4 = Strip(Centre(Shadow_Colour || Copies('',Length(BBS_Name) + 40 + Length(Day) + Length(Text_Month) + Length(Year)),83),'T')
        Address Cmd '@DEL ' || Text_Path || 'Most_Callers.Asc >Nul'

                Header.1 = LineIn(Text_Path || 'Temp_Most_Callers.Asc')
                Call Stream Text_Path || 'Temp_Most_Callers.Asc','c','Close'
                Do i = 1 to Header.0
                   Call LineOut Text_Path || 'Most_Callers.Asc',Header.i
                   Call LineIn Text_Path || 'Temp_Most_Callers.Asc'
                End
                Do While Lines(Text_Path || 'Temp_Most_Callers.Asc') = 1
                   rc = LineIn(Text_Path || 'Temp_Most_Callers.Asc')
                   Call LineOut Text_Path || 'Most_Callers.Asc',rc
                End
                Call Stream Text_Path || 'Most_Callers.Asc','c','Close'
                Call Stream Text_Path || 'Temp_Most_Callers.Asc','c','Close'
        Address Cmd '@DEL 'Text_Path || 'Temp_Most_Callers.Asc >Nul'
                Call AdeptPrint Line, ' Done!'
         End

         /* Recompile Lists */
         Call AdeptPrint Line, '\r\n{FG Re-Compiling Previous Days Lists ... '
         Old = 9
     Address Cmd '@Del 'Text_Path || Old || '_Days_Old.Asc >NUL'
         rc = Month_Convert(Month)
         Old_Year = Year
         Do 9
           Old = Old - 1
           rc = Stream(Text_Path || Old || '_Days_Old.Asc','c','query exists')
           If rc = '' Then Do
                  Call AdeptLog Line, 3, 'AdeptCaller: (Error) Cannot find file ' || Old || '_Days_Old.Asc'
                  Iterate
           End
           Old_File = Old + 1
           Rebuild_File = Text_Path || Old || '_Days_Old.Asc'
           New_File = Text_Path || Old_File || '_Days_Old.Asc'
           If Old_File >= Todays_Day Then Do
                  Diff = Old_File - Todays_Day
                  Check_Month = Month - 1
                  File_Day = Days_In_Month - Diff
           End
           If Old_File < Todays_Day Then Do
                  File_Day = Todays_Day - Old_File
                  Text_Month = Month_Convert(Month)
       End
           Else Text_Month = Month_Convert(Month - 1)
           rc = Tense_Convert(File_Day)
           Difference = Old + 1
           If Difference = 1 Then How_Long = "Day"
           If Difference \= 1 Then How_Long = "Days"
           Call Header_Init

       Header.3 = Strip(Centre(Shadow_Colour || "" || Title_Colour " Callers to " || BBS_Name || " on the " || File_Day || Tense || " " || Text_Month || " " || Year || " (" || Difference || " " || How_Long || " Ago) {B1",92),'T')
       Header.4 = Strip(Centre(Shadow_Colour || Copies('',Length(BBS_Name) + 33 + Length(File_Day) + Length(Text_Month) + Length(Difference) + Length(How_Long) + Length(Year)),81),'T')
           Header.1 = LineIn(Rebuild_File)
           Do i = 1 To Header.0
                  Call LineOut New_File,Header.i
           End
           Do Header.0 - 1
                  Call LineIn Rebuild_File
           End
           Do While Lines(Rebuild_File) = 1
                 In = LineIn(Rebuild_File)
                 Call LineOut New_File,In
           End
           Call Stream Rebuild_File,'c','Close'
           Call Stream New_File,'c','Close'
       Address Cmd '@Del ' || Rebuild_File || ' >NUL'
           Year = Old_Year
         End
     Call AdeptPrint Line, 'Done!\r\n\r\n'
         Call Today
Return
/*----------------------------------------------------------------------------*/

/*-----| Month Conversion |---------------------------------------------------*/
Month_Convert:
        Parse Arg Month_To_Convert
        Select                                                                            /* This is a CASE Statement */
                  When (Month_To_Convert = 01) Then Do
                         Month_To_Convert = 'January'
                         Days_In_Month = 31
                  End
                  When (Month_To_Convert = 02) Then Do
                         Month_To_Convert = 'February'
                         Days_In_Month = 28
                  End
                  When (Month_To_Convert = 03) Then Do
                         Month_To_Convert = 'March'
                         Days_In_Month = 31
                  End
                  When (Month_To_Convert = 04) Then Do
                         Month_To_Convert = 'April'
                         Days_In_Month = 30
                  End
                  When (Month_To_Convert = 05) Then Do
                         Month_To_Convert = 'May'
                         Days_In_Month = 31
                  End
                  When (Month_To_Convert = 06) Then Do
                         Month_To_Convert = 'June'
                         Days_In_Month = 30
                  End
                  When (Month_To_Convert = 07) Then Do
                         Month_To_Convert = 'July'
                         Days_In_Month = 31
                  End
                  When (Month_To_Convert = 08) Then Do
                         Month_To_Convert = 'August'
                         Days_In_Month = 31
                  End
                  When (Month_To_Convert = 09) Then Do
                         Month_To_Convert = 'September'
                         Days_In_Month = 30
                  End
                  When (Month_To_Convert = 10) Then Do
                         Month_To_Convert = 'October'
                         Days_In_Month = 31
                  End
                  When (Month_To_Convert = 11) Then Do
                         Month_To_Convert = 'November'
                         Days_In_Month = 30
                  End
                  When (Month_To_Convert = 12) Then Do
                         Month_To_Convert = 'December'
                         Days_In_Month = 31
                  End
                Otherwise
                  Month_To_Convert = 'December'
                  Days_In_Month = 31
                  Year = Year - 1
        End
Return Month_To_Convert
/*----------------------------------------------------------------------------*/

/*-----| Tense Conversion |---------------------------------------------------*/
Tense_Convert:
        Parse Arg Var_To_Convert
        Select
                When (Var_To_Convert = 01) | (Var_To_Convert = 21) | (Var_To_Convert = 31) Then Tense = 'st'
                When (Var_To_Convert = 02) | (Var_To_Convert = 22) Then Tense = 'nd'
                When (Var_To_Convert = 03) | (Var_To_Convert = 23) Then Tense = 'rd'
          Otherwise
                Tense = 'th'
        End
Return Var_To_Convert
/*----------------------------------------------------------------------------*/

/*-----| Local Login Warning |------------------------------------------------*/
Local:
   Call AdeptPrint Line, '\r\n{FGAdeptCaller: {FBLocal Login Detected, not adding to Caller Lists'
   Exit
Return
/*----------------------------------------------------------------------------*/

Exit
