/* A Recent Callers list generator for AdeptXBBS!

  This CMD File is used to VIEW the Tcall.Asc that AtEnd.Cmd generates

  This script was originally written by Julie Strietelmeier
  (julie@cel.cummins.com) on 03-05-95

  Modified 04-23-95 by Robert Stephens - 3:622/407
  (ourjs@net-unix.newcastle.edu.au)
  aka Jewfish in IRC #adept

    See AtEnd.Cmd for more information.                                       */

ARG Line_Variable

/*
-------------------------------------------------------------------------------
 Configuration for Callers.Cmd
------------------------------------------------------------------------------- */

/*callfile = 'e:\orion\text\oneliner.asc'  CHANGE this line to YOUR Adept Path */
CountColor = "{FG"               /* Sets the FOREGROUND color of the counter */
BackColor = "{B2"         /* Sets the BACKGROUND color for the WHOLE display */

/*                NOTE! Set the Foreground Color in AtEnd.Cmd
-------------------------------------------------------------------------------
 Congfiguration End
-------------------------------------------------------------------------------

                       Adept Color META Codes
                       ~~~~~~~~~~~~~~~~~~~~~~~
+---------------------------------------------------------------------+
|  Background ANSI color :                                            |
|                                                                     |
| {B1  --  Black        {B2  --  Dark blue     {B3  --  Dark green    |
| {B4  --  Dark magenta {B5  --  Dark red      {B6  --  Dark cyan     |
| {B7  --  Brown        {B8  --  Light gray                           |
|                                                                     |
|           ** See AtEnd.Cmd for Foreground Meta Codes **             |
+---------------------------------------------------------------------+
*/

today = DATE("U")
no_lines = adeptgetvar(Line_Variable,46)
bbsname = adeptgetvar(Line_Variable,137)
header = 5
page = no_lines
no_lines = no_lines - header
count = 1

Call AdeptCls Line_Variable 
Call AdeptPrint Line_Variable,'\r\n'
Call AdeptPrint Line_Variable,'[0;1;33;44m [37mThe DogStar BBS One Liners Door  [33mĿ  [34mby Mario Dulisse   - 08/05/95      [0;30;46m [40m\r\n'
Call AdeptPrint Line_Variable,'[A[79C[46m [1;33;44m                                     [1C[46m [40m\r\n'
/*AdeptPrint Line_Variable,'[A[79C[46m [37;44mCall #   User Name            Node   Baud   Location          LogOn  LogOff  [1C[46m [40m\r\n'
Call AdeptPrint Line_Variable,'[A[79C[46m  [0;30;46m  [40m'
*/
/* Routine to display the tcall.asc file      */
/* This will display a certain number of lines to the caller depending  */
/* on what they have set their screen lines to.                      */
/* I did this so that if your tcall.asc gets large, it won't scroll off */
/* the screen                                                       */
callfile = 'e:\orion\text\oneliner.asc'
check = lines(callfile)
DO WHILE check > 0
   entry = linein(callfile)

      IF count >= 100 THEN DO
         Call AdeptPrint Line_Variable,'\r'BackColor'[K'CountColor''BackColor
      END
      if count <= 99 then do
         Call AdeptPrint Line_Variable,'\r'BackColor'[K'CountColor''BackColor
      end
      if count <= 9 then do
         Call AdeptPrint Line_Variable,'\r'BackColor'[K'CountColor''BackColor
      end
     Call AdeptPrint Line_Variable,entry'\r\n'
      count = count + 1
      no_lines = no_lines - 1
        if no_lines = 0 then do
           Call AdeptPrint Line_Variable,"More Y/n "
           kk=AdeptInput(Line_Variable,1,1)
           if kk = 'N' then exit
           if kk = 'n' then exit
           no_lines = page
        end
check = lines(callfile)
end
count = count - 1
/* AdeptPrint(Line_Variable,'\r[41m[K [33m* [37mTotal System Calls Today = 'count'[0m\r\n')*/
Stream(callfile,'c','close')
Call AdeptHitReturn Line_Variable
/*
-------------------------------------------------------------------------------
 Configuration for Oneliners.Cmd
------------------------------------------------------------------------------- */

/* asciifile = 'e:\orion\text\oneliner.asc'  This is the OUTPUT file, change */
                                       /* this to the correct PATH */
NameColor   = "{FG"                    /* Color of Callers Name */
NodeColor   = "{FB"                    /* Color of Node Number */
BaudColor   = "{FB"                    /* Baud Rate Color */
CityColor   = "{FF"                    /* Users Location Color */
LogOnColor  = "{FG"                    /* LogOn Color */
LogOffColor = "{FG"                    /* LogOff Color */

/*              NOTE! You set the Background Color in Callers.Cmd
-------------------------------------------------------------------------------
 Congfiguration End
-------------------------------------------------------------------------------

                        Adept Color META Codes
                        ~~~~~~~~~~~~~~~~~~~~~~
+---------------------------------------------------------------------+
| Foreground ANSI Color :                                             |
| {F1  --  Black        {F2  --  Dark blue     {F3  --  Dark green    |
| {F4  --  Dark cyan    {F5  --  Dark red      {F6  --  Dark magenta  |
| {F7  --  Brown        {F8  --  Light gray    {F9  --  Dark gray     |
| {FA  --  Blue         {FB  --  Green         {FC  --  Cyan          |
| {FD  --  Red          {FE  --  Magenta       {FF  --  Yellow        |
| {FG  --  White                                                      |
+---------------------------------------------------------------------+
*/
name = adeptgetvar(Line_Variable,2)
Call AdeptPrint Line_Variable,"Add a ONEliner ? "
c1=AdeptInput(Line_Variable,1,1)
if c1 = '' then exit
if c1 = 'n' then exit
if c1 = 'N' then exit
Call AdeptPrint Line_Variable,"\r\nEnter your comment now, max 80 characters ... \r\n"
c6 = AdeptInput(Line_Variable,1,255,,,,,)
if c6 = '' then exit
asciifile = 'e:\orion\text\oneliner.asc'
t=lineout(asciifile,"{FB"name" - {FF"c6)
/* t=lineout(asciifile,c6) */
Stream(asciifile,'c','close')
return
/*                        Have a nice day! - Jewfish                          */
