/* Who's Online REXX prg */
/* Last Revised Feb 23/97*/
ARG line


/* SETUP THE VARIABLES HERE */

user.0 = 65       /* Number of Nodes for the BBS + 1 For Local Line.
                      25 Lines + 1 Local = 26 */
sysoplevel = 1000 /* Used to view users no matter what their 'in userlist'
                     attribute is set to.  Name will be in Yellow */


/* PROGRAM BEGINS */

counter = 0
user_count = 0
sec = ADEPTGETVAR(line, 40)
DO UNTIL counter = user.0
  userid = ADEPTGETVAR(counter,2)
  userflags = ADEPTGETVAR(counter, 44)
  inlist = ADEPTCHECKBIT(line, 25, userflags)
  IF (inlist = 1) & (sec < sysoplevel) THEN
    userid = ''
  ELSE
    DO
      status = ADEPTLOCATION(counter)
      IF status = '' THEN
        status = 'New User'
      status = DELSTR(status, 25)
      baud = ADEPTGETVAR(counter, 233)
    END

  IF (LENGTH(userid) > 0) & (LENGTH(userid) <= 36) THEN
    DO
      usersec = AdeptGetVar(counter, 40)
      IF (inlist = 1) & (sec >= sysoplevel) THEN
        DO
          IF (usersec = sysoplevel) THEN /* SYSOP HIDDEN, Yellow Name */
            DO
              userid = INSERT('[1;34m[[1;33mSysOp[1;34m] [1;33m',userid)
              col = 71
            END
          ELSE
            DO
              userid = INSERT('[1;33m', userid) /* HIDDEN USER, Yellow Name */
              col = 49
            END
        END
      ELSE IF (usersec = sysoplevel) THEN   /* Sysop, normal list color */
        DO
          userid = INSERT('[1;34m[[1;33mSysOp[1;34m] [1;0m',userid)
          col = 70
        END
      ELSE
        DO
          userid = INSERT('[1;0m', userid) /* User, Normal list color */
          col = 40
        END
      status = INSERT('[1;32m', status, 0)
      out = ''
      IF counter < 10 THEN
        out = INSERT(counter, out,2)
      ELSE IF (counter < 100) THEN
        out = INSERT(counter, out,1)
      ELSE
        out = INSERT(counter, out, 0)

      out = INSERT(userid, out, 6)
      out = INSERT(status, out, col)
      out = INSERT(baud, out, col + 32)
      user_count = user_count + 1
      users.user_count = out
    END
    counter = counter + 1
END

Call AdeptPrint line, '[2J[0;32mUsers Currently Online:\r\n'
Call AdeptPrint line, '\r\nLINE USER-ID                              Status                    Baud\r\n'

DO i = 1 TO user_count
  CALL AdeptPrint line, '{FB'users.i'\r\n'
END

Call AdeptPrint line, '{F8*Press a Key to Continue*'
Call AdeptPause line
EXIT
