/* Simple REALLY SIMPLE Not very useful Rexx script for multi-node chat */

/*
   I will continue to update this with each upcomming build of the alpha
   releases until it reaches the point where it can totally 100% replace
   the internal chat support.
*/

ARG Line

SysMsg = 1
PrivMsg = 1
PubMsg = 1

UserName = AdeptGetvar(line, 1)
UserNode = Line

LastCommand = ''
InputText = ''

KeyList = D2C(9)

ContLoop = 1

AdeptInitRexx(line)

RetC = AdeptSysChatConnectUser(line)

if(RetC == 1) then do
   RetC = AdeptSysChatJoinConf(line, "Main")
end
else do
   AdeptPrint(line, "\r\n\n[0m[KChat server unavailable\r\n{PC")
   exit
end

AdeptPrint(line, '[0m[2J[1;1H\r\n/Q to exit.  /? for quick help\r\n\n')

AdeptPrint(line, '\rYou have entered the "Main" conference.\r\n\n')

if(RetC == 2) then do
    SendString = '{FE[{FG' || UserNode || '{F8-{FB' || UserName || '{FE] {FC{ZZ' || 'Entering...'
    AdeptSysChatPubMsg(line, SendString)
end


do while (ContLoop == 1)

/*
   Remember the Buffer name at least when passing it to rexx must be in
   upper case.  I.E. UserText
*/

    /*
       Displays prompt #416 as the chat input prompt, same as standard
       multi-node chat
    */
    USERTEXT = ""

    Command = ''
    NodeTo = ''
    MsgText = ''

    if(InputText \= '') then
        RetC = AdeptSysChatInput(line, "USERTEXT", KeyList, InputText)
    else
        RetC = AdeptSysChatInput(line, "USERTEXT", KeyList)

    InputText = ''

    if(RetC == 9) then do
        if(LastCommand \= '') then do
           InputText = LastCommand
           RetC = 1
        end
       ITERATE
    end

    if(RetC \= 1) then do
       if(RetC == IRC_CHATWAITING) then do
          RetC = ProcessChatMsg(line)
       end

       if(RetC == IRC_CHATDOWN) then do
          RetC = ReconnectUser(line)
          if(RetC \= 1) then do
              AdeptSysChatLeaveConf(line)
              exit
          end
       ITERATE
       end

       if(RetC == LOSTCARRIER) then do
          SendString = '{FE[{FG' || UserNode || '{F8-{FB' || UserName || '{FE] {FC{ZZ' || ' Leaving, Dropped Carrier...'
          AdeptSysChatPubMsg(line, SendString)
          AdeptSysChatLeaveConf(line)
          exit
       end

       if(RetC == IRC_NOTIMELEFT) then do
          SendString = '{FE[{FG' || UserNode || '{F8-{FB' || UserName || '{FE] {FC{ZZ' || ' Leaving, No time remaining...'
          AdeptSysChatPubMsg(line, SendString)
          AdeptSysChatLeaveConf(line)
          exit
       end

       if(RetC == IRC_IDLETIMEOUT) then do
          SendString = '{FE[{FG' || UserNode || '{F8-{FB' || UserName || '{FE] {FC{ZZ' || ' Leaving, Sleeping at the keys...'
          AdeptSysChatPubMsg(line, SendString)
          AdeptSysChatLeaveConf(line)
          exit
       end
       ITERATE
    end
    else
    if(RetC == 1) then do

       if(UserText == '') then Iterate

       LastCommand = UserText

       AdeptPrint(line, '\r\n')

       if(UserText == '/' | Left(UserText,1) == '/') then do
            RetC = FillData(UserText)

            if(Command == '/Q' | Command == '/E') then do
               SendString = '{FE[{FG' || UserNode || '{F8-{FB' || UserName || '{FE] {FC{ZZ' || 'Leaving...'
               AdeptSysChatPubMsg(line, SendString)
               AdeptSysChatLeaveConf(line)
               exit
            end

            if(Command == '/W') then do
               AdeptMenuType(line, 55)
               AdeptPrint(line, '\r\n')
               RetC = 0
               ITERATE
            end

            if(Command == '/A') then do
               AdeptMenuType(line, 52)
               AdeptPrint(line, '\r\n')
               RetC = 0
               ITERATE
            end

            if(Command == '/L') then do
               AdeptMenuType(line, 53)
               AdeptPrint(line, '\r\n')
               RetC = 0
               ITERATE
            end

            if(Command == '/T') then do
               RetC = ShowTime(line)
               ITERATE
            end

            if(Command == '/?') then do
               RetC = ShowHelp(line)
               ITERATE
            end

            if(Command == '/PUBMSG') then do
               if(PubMsg == 1) then do
                  PubMsg = 0
                  AdeptPrint(line, '\r{FC--- {FGPublic message annoucement turned off {FC---\r\n')
               end
               else do
                  PubMsg = 1
                  AdeptPrint(line, '\r{FC--- {FGPublic message annoucement turned on {FC---\r\n')
               end
               ITERATE
            end

            if(Command == '/PRIVMSG') then do
               if(PrivMsg == 1) then do
                  PrivMsg = 0
                  AdeptPrint(line, '\r{FC--- {FGPrivate message annoucement turned off {FC---\r\n')
               end
               else do
                  PrivMsg = 1
                  AdeptPrint(line, '\r{FC--- {FGPrivate message annoucement turned on {FC---\r\n')
               end
               ITERATE
            end

            if(Command == '/SYSMSG') then do
               if(SysMsg == 1) then do
                  SysMsg = 0
                  AdeptPrint(line, '\r{FC--- {FGReceive system messages turned off {FC---\r\n')
               end
               else do
                  SysMsg = 1
                  AdeptPrint(line, '\r{FC--- {FGReceive system messages turned on {FC---\r\n')
               end
               ITERATE
            end

            if(Command == '/S') then do
               if(NodeTo \= '' & MsgText \= '') then do
                   SendString = '{FE[{FG' || UserNode || '{F8-{FB' || UserName || '{FD, Pvt Msg{FE] {FC{ZZ' || MsgText
                   AdeptSysChatPrivMsg(line, NodeTo, SendString)
                   NodeUserName = AdeptGetVar(NodeTo, 1)
                   if(NodeUserName \= '') then
                       if(PrivMsg == 1) then AdeptPrint(line, '\r{FC--- {FGPrivate message sent to {FF' || NodeUserName || '{FG on node {FF' || NodeTo || '{FC ---\r\n')
                   else
                       if(PrivMsg == 1) then AdeptPrint(line, '\r{FC--- {FGPrivate message not sent, No one on node {FF' || NodeTo || '{FC ---\r\n')
               end
               ITERATE
            end
            if(Command == '/ME') then do
                SendString = '{F8* {FC' || UserName || '{ZZ ' || MsgText
                AdeptSysChatNoPrePubMsg(line, SendString)
                if(PubMsg == 1) then AdeptPrint(line, '\r{FC--- {FGPublic action sent {FC---\r\n')
               ITERATE
            end
            AdeptPrint(line, '\r{FC--- {FGInvalid command "{FF' || Command || '{FG" press /? for help{FC---\r\n')
       end
       else
       do
           if(Usertext \= '') then do
                SendString = '{FE[{FG' || UserNode || '{F8-{FB' || UserName || '{FE] {FC{ZZ' || UserText
                AdeptSysChatPubMsg(line, SendString)
                if(PubMsg == 1) then AdeptPrint(line, '\r{FC--- {FGPublic Message Sent {FC---\r\n')
                ITERATE
           end
       end
    AdeptSleep(line, 128)
    end
    AdeptSleep(line, 128)
end

ProcessChatMsg:

   ARG line

   do while(AdeptSysChatMsgWaiting(line) == 1)

       RetC = AdeptSysChatGetMsg(line)

       if(RetC == 3) then do
          if(PktType == 100) then do
              AdeptPrint(line, "\r" || ChatMsgData || "\r\n")
              return 0
          end
          else
          if(PktType == 101) then do
              AdeptPrint(line, "\r" || ChatMsgData || "\r\n")
              return 0
          end
          else
          if(PktType == 102) then do
              AdeptPrint(line, "\r" || ChatMsgData || "\r\n")
              return 0
          end
          if(PktType == 105 & SysMsg == 1) then do
              AdeptPrint(line, "\r" || ChatMsgData || "\r\n")
              return 0
          end
       end
       AdeptSleep(line, 1);
   end
return 0

ReconnectUser:

   ARG line

   count = 1
   AdeptPrint(line, '\rChat server has gone down.. Trying to reconnect.  Please stand by...\r\n');

   RetC = AdeptSysChatReConnectUser(line)

   do while(RetC \= 1 & count < 6)
       AdeptPrint(line, '\rTry ' || count ||' of 5 Please stand by...\r\n');
       AdeptSleep(line, 4000);
       count = count + 1;
       RetC = AdeptSysChatReConnectUser(line)
   end

   RetC = AdeptSysChatUserConnected(line)

   if(RetC \= 1) then do
        AdeptPrint(line, '\rCould not reconnect to chat server, exiting...\r\n');
        return RetC
   end
   else do
        AdeptPrint(line, '\rChat server reconnected, you may continue to chat.\r\n');
        return RetC
   end

return 0

FillData:

   Parse ARG uInput

   PARSE Var uInput Command ',' NodeTo ' ' MsgText

   if(Command == '') then Command = uInput

   if(Command == uInput) then do

      PoSit = Pos(' ', Command)

      if(PoSit == 0) then do
         Command = Translate(Command)
         return 0
      end

      PARSE Var uInput Command ' ' MsgText

      Command = Translate(Command)

      if(Command == '/ME') then return 0

      if(Command == '/S') then do
          PARSE Var MsgText NodeTo ' ' MsgText
      end

   end

   Command = Translate(Command)

   MsgText = NodeTo

return 0

ShowHelp:

   ARG line

   AdeptPrint(line, '\r\nItems in Brackets "[]" are required.\r\n\r\n')
   AdeptPrint(line, '/E or /Q                  - Exit chat mode\r\n')
   AdeptPrint(line, '/S,[node #] [message]     - Send a private message\r\n')
   AdeptPrint(line, '/T                        - Displays current time/date info\r\n')
   AdeptPrint(line, '/ME [Message]             - Perform a action\r\n')
   AdeptPrint(line, '/W                        - Show who else is on-line\r\n')
   AdeptPrint(line, '/A                        - Show all nodes status\r\n')
   AdeptPrint(line, '/L                        - Show who is in this channel\r\n')
   AdeptPrint(line, '/PUBMSG                   - Toggle --- Public Message Sent -- Off/On\r\n')
   AdeptPrint(line, '/PRIVMSG                  - Toggle --- Private Message Sent -- Off/On\r\n')
   AdeptPrint(line, '/SYSMSG                   - Toggle [System Messages] On/Off\r\n')
   AdeptPrint(line, '\r\n')

return 0

ShowTime:

   ARG line

   AdeptPrint(line, '\r{FFToday is: {FG{D8  {FFYou have {FG{T0 {FFminutes remaining this call.\r\n')

return 0

