/* A Recent Callers list generator for AdeptXBBS!

  This CMD File is used to VIEW the Tcall.Asc that AtEnd.Cmd generates

  This script was originally written by Julie Strietelmeier
  (julie@cel.cummins.com) on 03-05-95

  Modified 04-23-95 by Robert Stephens - 3:622/407
  (ourjs@net-unix.newcastle.edu.au)
  aka Jewfish in IRC #adept

    See AtEnd.Cmd for more information.                                       */

ARG Line_Variable

/*
-------------------------------------------------------------------------------
 Configuration for Callers.Cmd
------------------------------------------------------------------------------- */

callfile = 'd:\adept\text\calls.asc'  /* CHANGE this line to YOUR Adept Path */
CountColor = "{FC"               /* Sets the FOREGROUND color of the counter */
BackColor = "{B6"         /* Sets the BACKGROUND color for the WHOLE display */

/*                NOTE! Set the Foreground Color in AtEnd.Cmd
-------------------------------------------------------------------------------
 Congfiguration End
-------------------------------------------------------------------------------

                       Adept Color META Codes
                       ~~~~~~~~~~~~~~~~~~~~~~~
+---------------------------------------------------------------------+
|  Background ANSI color :                                            |
|                                                                     |
| {B1  --  Black        {B2  --  Dark blue     {B3  --  Dark green    |
| {B4  --  Dark magenta {B5  --  Dark red      {B6  --  Dark cyan     |
| {B7  --  Brown        {B8  --  Light gray                           |
|                                                                     |
|           ** See AtEnd.Cmd for Foreground Meta Codes **             |
+---------------------------------------------------------------------+
*/

today = DATE("U")
no_lines = AdeptGetVar(Line_Variable,46)
bbsname = AdeptGetVar(Line_Variable,137)
header = 5
page = no_lines
no_lines = no_lines - header
count = 1

Call AdeptCls Line_Variable
Call AdeptPrint Line_Variable,'\r\n'
Call AdeptPrint Line_Variable,'[0;1;33;44m [37mTodays Callers to The DogStar BBS [33mĿ  [34mby Robert Stephens - 17/04/95      [0;30;46m [40m\r\n'
Call AdeptPrint Line_Variable,'[A[79C[46m [1;33;44m                                     [1C[46m [40m\r\n'
Call AdeptPrint Line_Variable,'[A[79C[46m [37;44mCall #   User Name            Node   Baud   Location          LogOn    [1C[46m [40m\r\n'
Call AdeptPrint Line_Variable,'[A[79C[46m  [0;30;46m  [40m'

check = lines(callfile)
DO WHILE check > 0
   entry = linein(callfile)
   entry1 = left(entry,78)
      IF count >= 100 THEN DO
         Call AdeptPrint Line_Variable,'\r'BackColor'[K'CountColor''BackColor' 'count
      END
      if count <= 99 then do
         Call AdeptPrint Line_Variable,'\r'BackColor'[K'CountColor''BackColor'  'count
      end
      if count <= 9 then do
         Call AdeptPrint Line_Variable,'\r'BackColor'[K'CountColor''BackColor'   'count
      end
     Call AdeptPrint Line_Variable,entry1'\r\n'
      count = count + 1
      no_lines = no_lines - 1
        if no_lines = 0 then do
           Call AdeptPrint Line_Variable,'More? [Y/n] '
           kk=AdeptInput(Line_Variable,1,1,,,,,)
           if kk = 'n' then exit
           if kk = 'N' then exit
           no_lines = page
        end
check = lines(callfile)
end
count = count - 1
Call AdeptPrint Line_Variable,'\r[41m[K [33m* [37mTotal System Calls Today = 'count'[0m\r\n'
Call AdeptHitReturn Line_Variable

